package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletCO2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get CO2 Concentration")
    public @ActionOutput(name = "co2Concentration", type="int")
           Map<String, Object> getCO2Concentration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletCO2)this.handler.getDevice()).getCO2Concentration();
        result.put("co2Concentration", value);
        return result;
    }

    public static Map<String, Object> getCO2Concentration(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletCO2Actions) {
            return ((BrickletCO2Actions) actions).getCO2Concentration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletCO2Actions class.");
        }
    }
}
