package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletEPaper296x128Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Draw")
    public void draw(
            ) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).draw();
    }

    public static void draw(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).draw();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Get Draw Status")
    public @ActionOutput(name = "drawStatus", type="int")
           Map<String, Object> getDrawStatus(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletEPaper296x128)this.handler.getDevice()).getDrawStatus();
        result.put("drawStatus", value);
        return result;
    }

    public static Map<String, Object> getDrawStatus(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            return ((BrickletEPaper296x128Actions) actions).getDrawStatus();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Write Black White")
    public void writeBlackWhite(
            @ActionInput(name = "xStart") int xStart,
            @ActionInput(name = "yStart") int yStart,
            @ActionInput(name = "xEnd") int xEnd,
            @ActionInput(name = "yEnd") int yEnd,
            @ActionInput(name = "pixels") boolean[] pixels) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).writeBlackWhite(xStart, yStart, xEnd, yEnd, pixels);
    }

    public static void writeBlackWhite(@Nullable ThingActions actions, int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).writeBlackWhite(xStart, yStart, xEnd, yEnd, pixels);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Read Black White")
    public @ActionOutput(name = "pixels", type="boolean[]")
           Map<String, Object> readBlackWhite(
            @ActionInput(name = "xStart") int xStart,
            @ActionInput(name = "yStart") int yStart,
            @ActionInput(name = "xEnd") int xEnd,
            @ActionInput(name = "yEnd") int yEnd) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        boolean[] value = ((BrickletEPaper296x128)this.handler.getDevice()).readBlackWhite(xStart, yStart, xEnd, yEnd);
        result.put("pixels", value);
        return result;
    }

    public static Map<String, Object> readBlackWhite(@Nullable ThingActions actions, int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            return ((BrickletEPaper296x128Actions) actions).readBlackWhite(xStart, yStart, xEnd, yEnd);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Write Color")
    public void writeColor(
            @ActionInput(name = "xStart") int xStart,
            @ActionInput(name = "yStart") int yStart,
            @ActionInput(name = "xEnd") int xEnd,
            @ActionInput(name = "yEnd") int yEnd,
            @ActionInput(name = "pixels") boolean[] pixels) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).writeColor(xStart, yStart, xEnd, yEnd, pixels);
    }

    public static void writeColor(@Nullable ThingActions actions, int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).writeColor(xStart, yStart, xEnd, yEnd, pixels);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Read Color")
    public @ActionOutput(name = "pixels", type="boolean[]")
           Map<String, Object> readColor(
            @ActionInput(name = "xStart") int xStart,
            @ActionInput(name = "yStart") int yStart,
            @ActionInput(name = "xEnd") int xEnd,
            @ActionInput(name = "yEnd") int yEnd) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        boolean[] value = ((BrickletEPaper296x128)this.handler.getDevice()).readColor(xStart, yStart, xEnd, yEnd);
        result.put("pixels", value);
        return result;
    }

    public static Map<String, Object> readColor(@Nullable ThingActions actions, int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            return ((BrickletEPaper296x128Actions) actions).readColor(xStart, yStart, xEnd, yEnd);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Fill Display")
    public void fillDisplay(
            @ActionInput(name = "color") int color) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).fillDisplay(color);
    }

    public static void fillDisplay(@Nullable ThingActions actions, int color) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).fillDisplay(color);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Draw Text")
    public void drawText(
            @ActionInput(name = "positionX") int positionX,
            @ActionInput(name = "positionY") int positionY,
            @ActionInput(name = "font") int font,
            @ActionInput(name = "color") int color,
            @ActionInput(name = "orientation") int orientation,
            @ActionInput(name = "text") String text) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).drawText(positionX, positionY, font, color, orientation, text);
    }

    public static void drawText(@Nullable ThingActions actions, int positionX, int positionY, int font, int color, int orientation, String text) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).drawText(positionX, positionY, font, color, orientation, text);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Draw Line")
    public void drawLine(
            @ActionInput(name = "positionXStart") int positionXStart,
            @ActionInput(name = "positionYStart") int positionYStart,
            @ActionInput(name = "positionXEnd") int positionXEnd,
            @ActionInput(name = "positionYEnd") int positionYEnd,
            @ActionInput(name = "color") int color) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).drawLine(positionXStart, positionYStart, positionXEnd, positionYEnd, color);
    }

    public static void drawLine(@Nullable ThingActions actions, int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, int color) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).drawLine(positionXStart, positionYStart, positionXEnd, positionYEnd, color);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Draw Box")
    public void drawBox(
            @ActionInput(name = "positionXStart") int positionXStart,
            @ActionInput(name = "positionYStart") int positionYStart,
            @ActionInput(name = "positionXEnd") int positionXEnd,
            @ActionInput(name = "positionYEnd") int positionYEnd,
            @ActionInput(name = "fill") boolean fill,
            @ActionInput(name = "color") int color) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).drawBox(positionXStart, positionYStart, positionXEnd, positionYEnd, fill, color);
    }

    public static void drawBox(@Nullable ThingActions actions, int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean fill, int color) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).drawBox(positionXStart, positionYStart, positionXEnd, positionYEnd, fill, color);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Set Update Mode")
    public void setUpdateMode(
            @ActionInput(name = "updateMode") int updateMode) throws TinkerforgeException {
        ((BrickletEPaper296x128)this.handler.getDevice()).setUpdateMode(updateMode);
    }

    public static void setUpdateMode(@Nullable ThingActions actions, int updateMode) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            ((BrickletEPaper296x128Actions) actions).setUpdateMode(updateMode);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Get Update Mode")
    public @ActionOutput(name = "updateMode", type="int")
           Map<String, Object> getUpdateMode(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletEPaper296x128)this.handler.getDevice()).getUpdateMode();
        result.put("updateMode", value);
        return result;
    }

    public static Map<String, Object> getUpdateMode(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            return ((BrickletEPaper296x128Actions) actions).getUpdateMode();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }

    @RuleAction(label = "Get Display Type")
    public @ActionOutput(name = "displayType", type="int")
           Map<String, Object> getDisplayType(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletEPaper296x128)this.handler.getDevice()).getDisplayType();
        result.put("displayType", value);
        return result;
    }

    public static Map<String, Object> getDisplayType(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletEPaper296x128Actions) {
            return ((BrickletEPaper296x128Actions) actions).getDisplayType();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletEPaper296x128Actions class.");
        }
    }
}
