package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDual020mAV2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type="int")
           Map<String, Object> getCurrent(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getCurrent(channel);
        result.put("current", value);
        return result;
    }

    public static Map<String, Object> getCurrent(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).getCurrent(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Channel LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> getChannelLEDConfig(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getChannelLEDConfig(channel);
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> getChannelLEDConfig(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).getChannelLEDConfig(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Channel LED Status Config")
    public @ActionOutput(name = "min", type="int")
           @ActionOutput(name = "max", type="int")
           @ActionOutput(name = "config", type="int")
           Map<String, Object> getChannelLEDStatusConfig(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        BrickletIndustrialDual020mAV2.ChannelLEDStatusConfig value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getChannelLEDStatusConfig(channel);
        result.put("min", value.min);
        result.put("max", value.max);
        result.put("config", value.config);
        return result;
    }

    public static Map<String, Object> getChannelLEDStatusConfig(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).getChannelLEDStatusConfig(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Sample Rate")
    public @ActionOutput(name = "rate", type="int")
           Map<String, Object> getSampleRate(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getSampleRate();
        result.put("rate", value);
        return result;
    }

    public static Map<String, Object> getSampleRate(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).getSampleRate();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }

    @RuleAction(label = "Get Gain")
    public @ActionOutput(name = "gain", type="int")
           Map<String, Object> getGain(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletIndustrialDual020mAV2)this.handler.getDevice()).getGain();
        result.put("gain", value);
        return result;
    }

    public static Map<String, Object> getGain(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAV2Actions) {
            return ((BrickletIndustrialDual020mAV2Actions) actions).getGain();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAV2Actions class.");
        }
    }
}
