/* ***********************************************************
 * This file was automatically generated on 2019-11-06.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4 galvanically isolated solid state relays
 */
public class BrickletIndustrialQuadRelayV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2102;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Quad Relay Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "industrialquadrelayv2", DEVICE_IDENTIFIER, BrickletIndustrialQuadRelayV2.class, BrickletIndustrialQuadRelayV2Actions.class);

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)3;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)4;
	public final static byte FUNCTION_SET_SELECTED_VALUE = (byte)5;
	public final static byte FUNCTION_SET_CHANNEL_LED_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_CHANNEL_LED_CONFIG = (byte)7;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_MONOFLOP_DONE = 8;

	public final static int CHANNEL_LED_CONFIG_OFF = 0;
	public final static int CHANNEL_LED_CONFIG_ON = 1;
	public final static int CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Monoflop {
		public boolean value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the channel and the current value of the channel
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int channel, boolean value);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialQuadRelayV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CHANNEL_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHANNEL_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				boolean value = (bb.get()) != 0;

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(channel, value);
				}
			}
		};
	}

	/**
	 * Sets the value of all four relays. A value of *true* closes the
	 * relay and a value of *false* opens the relay.
	 * 
	 * Use {@link BrickletIndustrialQuadRelayV2#setSelectedValue(int, boolean)} to only change one relay.
	 * 
	 * All running monoflop timers will be aborted if this function is called.
	 */
	public void setValue(boolean[] value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_VALUE, this);


		byte[] valueBits = new byte[1];
		Arrays.fill(valueBits, (byte)0);

		for (int i = 0; i < 4; i++) {
			if (value[i]) {
				valueBits[i / 8] |= 1 << (i % 8);
			}
		}
		for (int i = 0; i < 1; i++) {
			bb.put(valueBits[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the values as set by {@link BrickletIndustrialQuadRelayV2#setValue(boolean[])}.
	 */
	public boolean[] getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		byte[] valueBits = new byte[1];
		bb.get(valueBits);
		boolean[] value = new boolean[4];
		for (int i = 0; i < 4; i++) {
			value[i] = (valueBits[i / 8] & (1 << (i % 8))) != 0;
		}


		return value;
	}

	/**
	 * Configures a monoflop of the specified channel.
	 * 
	 * The second parameter is the desired value of the specified
	 * channel. A *true* means relay closed and a *false* means relay open.
	 * 
	 * The third parameter indicates the time (in ms) that the channels should hold
	 * the value.
	 * 
	 * If this function is called with the parameters (0, 1, 1500) channel 0 will
	 * close and in 1.5s channel 0 will open again
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and a Industrial Quad Relay Bricklet 2.0 connected to one of
	 * the slave stacks. You can now call this function every second, with a time
	 * parameter of two seconds and channel 0 closed. Channel 0 will be closed all the
	 * time. If now the RS485 connection is lost, then channel 0 will be opened in at
	 * most two seconds.
	 */
	public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_MONOFLOP, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given channel) the current value and the time as set by
	 * {@link BrickletIndustrialQuadRelayV2#setMonoflop(int, boolean, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = (bb.get()) != 0;
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the output value of the specified channel without affecting the other
	 * channels.
	 * 
	 * A running monoflop timer for the specified channel will be aborted if this
	 * function is called.
	 */
	public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_VALUE, this);

		bb.put((byte)channel);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Each channel has a corresponding LED. You can turn the LED off, on or show a
	 * heartbeat. You can also set the LED to "Channel Status". In this mode the
	 * LED is on if the channel is high and off otherwise.
	 * 
	 * By default all channel LEDs are configured as "Channel Status".
	 */
	public void setChannelLEDConfig(int channel, int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CHANNEL_LED_CONFIG, this);

		bb.put((byte)channel);
		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the channel LED configuration as set by {@link BrickletIndustrialQuadRelayV2#setChannelLEDConfig(int, int)}
	 */
	public int getChannelLEDConfig(int channel) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CHANNEL_LED_CONFIG, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletIndustrialQuadRelayV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletIndustrialQuadRelayV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletIndustrialQuadRelayV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletIndustrialQuadRelayV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelayV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelayV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        this.addMonoflopDoneListener((channel, value) -> {if(channel == 0) {updateStateFn.accept("IndustrialQuadRelayV2Relay0", transformIndustrialQuadRelayV2Relay0Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 1) {updateStateFn.accept("IndustrialQuadRelayV2Relay1", transformIndustrialQuadRelayV2Relay1Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 2) {updateStateFn.accept("IndustrialQuadRelayV2Relay2", transformIndustrialQuadRelayV2Relay2Callback0(channel, value, cfg));}});
		this.addMonoflopDoneListener((channel, value) -> {if(channel == 3) {updateStateFn.accept("IndustrialQuadRelayV2Relay3", transformIndustrialQuadRelayV2Relay3Callback0(channel, value, cfg));}});
        
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Relay0").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(0, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Relay1").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(1, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Relay2").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(2, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Relay3").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(3, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Monofloprelay0").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Monofloprelay1").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Monofloprelay2").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayV2Monofloprelay3").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("IndustrialQuadRelayV2Relay0");
		result.add("IndustrialQuadRelayV2Relay1");
		result.add("IndustrialQuadRelayV2Relay2");
		result.add("IndustrialQuadRelayV2Relay3");
		result.add("IndustrialQuadRelayV2Monofloprelay0");
		result.add("IndustrialQuadRelayV2Monofloprelay1");
		result.add("IndustrialQuadRelayV2Monofloprelay2");
		result.add("IndustrialQuadRelayV2Monofloprelay3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IndustrialQuadRelayV2Relay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Relay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialQuadRelayV2Relay")).withDescription("NOT USED").build();
            case "IndustrialQuadRelayV2Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialQuadRelayV2Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Quad Relay Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated solid state relays").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IndustrialQuadRelayV2Relay0", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Relay")).withLabel("Relay 0").withDescription("Switches Relay 0. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Relay1", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Relay")).withLabel("Relay 1").withDescription("Switches Relay 1. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Relay2", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Relay")).withLabel("Relay 2").withDescription("Switches Relay 2. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Relay3", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Relay")).withLabel("Relay 3").withDescription("Switches Relay 3. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Monofloprelay0", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 0").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Monofloprelay1", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 1").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Monofloprelay2", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 2").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayV2Monofloprelay3", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 3").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:industrialquadrelayv2":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:IndustrialQuadRelayV2Relay":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("channelLEDConfig", Type.INTEGER).withDefault("3").withDescription("Each channel has a corresponding LED. You can turn the LED off, on or show a heartbeat. You can also set the LED to Channel Status. In this mode the LED is on if the channel is high and off otherwise.").withLabel("Channel LED Config").withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Channel Status"))).build()));
            case "channel-type:tinkerforge:IndustrialQuadRelayV2Monoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        switch(channel) {
            case "IndustrialQuadRelayV2Relay0": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Relay0Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Relay1": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Relay1Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Relay2": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Relay2Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Relay3": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Relay3Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Monofloprelay0": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(0);
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Monofloprelay0Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Monofloprelay1": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(1);
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Monofloprelay1Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Monofloprelay2": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(2);
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Monofloprelay2Getter0(value, cfg));
        }
                   return;
               }
            case "IndustrialQuadRelayV2Monofloprelay3": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop(3);
            if(true)
                updateStateFn.accept(channel, transformIndustrialQuadRelayV2Monofloprelay3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        switch(channel) {
            case "IndustrialQuadRelayV2Relay0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Relay1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Relay2":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(2, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Relay3":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(3, cmd == OnOffType.ON);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Monofloprelay0":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayV2Relay0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Monofloprelay1":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayV2Relay1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Monofloprelay2":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(2, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayV2Relay2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayV2Monofloprelay3":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(3, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayV2Relay3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay0Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay1Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay2Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay3Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay0Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay1Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay2Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Relay3Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Monofloprelay0Getter0(Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Monofloprelay1Getter0(Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Monofloprelay2Getter0(Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayV2Monofloprelay3Getter0(Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
}
