package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletPiezoSpeakerActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Beep")
    public void beep(
            @ActionInput(name = "duration") long duration,
            @ActionInput(name = "frequency") int frequency) throws TinkerforgeException {
        ((BrickletPiezoSpeaker)this.handler.getDevice()).beep(duration, frequency);
    }

    public static void beep(@Nullable ThingActions actions, long duration, int frequency) throws TinkerforgeException {
        if (actions instanceof BrickletPiezoSpeakerActions) {
            ((BrickletPiezoSpeakerActions) actions).beep(duration, frequency);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletPiezoSpeakerActions class.");
        }
    }

    @RuleAction(label = "Morse Code")
    public void morseCode(
            @ActionInput(name = "morse") String morse,
            @ActionInput(name = "frequency") int frequency) throws TinkerforgeException {
        ((BrickletPiezoSpeaker)this.handler.getDevice()).morseCode(morse, frequency);
    }

    public static void morseCode(@Nullable ThingActions actions, String morse, int frequency) throws TinkerforgeException {
        if (actions instanceof BrickletPiezoSpeakerActions) {
            ((BrickletPiezoSpeakerActions) actions).morseCode(morse, frequency);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletPiezoSpeakerActions class.");
        }
    }
}
