package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletRotaryEncoderV2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Count")
    public @ActionOutput(name = "count", type="int")
           Map<String, Object> getCount(
            @ActionInput(name = "reset") boolean reset) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRotaryEncoderV2)this.handler.getDevice()).getCount(reset);
        result.put("count", value);
        return result;
    }

    public static Map<String, Object> getCount(@Nullable ThingActions actions, boolean reset) throws TinkerforgeException {
        if (actions instanceof BrickletRotaryEncoderV2Actions) {
            return ((BrickletRotaryEncoderV2Actions) actions).getCount(reset);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRotaryEncoderV2Actions class.");
        }
    }

    @RuleAction(label = "Is Pressed")
    public @ActionOutput(name = "pressed", type="boolean")
           Map<String, Object> isPressed(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        boolean value = ((BrickletRotaryEncoderV2)this.handler.getDevice()).isPressed();
        result.put("pressed", value);
        return result;
    }

    public static Map<String, Object> isPressed(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRotaryEncoderV2Actions) {
            return ((BrickletRotaryEncoderV2Actions) actions).isPressed();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRotaryEncoderV2Actions class.");
        }
    }
}
